/*
 * pa3.h
 *
 *  Created on: Apr 8, 2018
 *      Author: Tan Nguyen
 *      Email: thanhtanpc@gmail.com
 *      Skype: thanh_tan_pc
 */

#ifndef PA3_H_
#define PA3_H_

#include <string>
#include <fstream>
#include <iostream>
#include <vector>
#include <sstream>
#include <iterator>
#include <stdexcept>
using namespace std;

class Stack {
private:
    int stackSize;
    std::vector<std::string> stack;
public:
    Stack();
    int size();
    void push(std::string addData);
    std::string pop();
    bool contains(std::string data);
    bool isEmpty();
    void printStack();
};

//Initializes Stack object by setting size to 0
Stack::Stack()
{
    stackSize = 0;
}

//Returns size of stack
int Stack::size()
{
    return stackSize;
}

//Adds a string to the stack object at the top of the container vector
void Stack::push(string addData)
{
    stack.push_back(addData);
    stackSize++;
}

//Returns the top most string from the container vector, deleting it from the container
//Whenever called, must have checks to see if the stack size goes to 0
string Stack::pop()
{
    string s = stack.back();
    stack.pop_back();
    stackSize--;
    return s;
}

//Checks if a given element is contained in the stack
bool Stack::contains(string data)
{
    if (stackSize != 0)
    {
        for (int i = 0; i < stackSize; i++)
        {
            if (stack[i] == data)
            {
                return true;
            }
        }
    }
    return false;
}

//Returns whether the stack is empty or not
bool Stack::isEmpty()
{
    if (stackSize == 0)
    {
        return true;
    }
    return false;
}

void Stack::printStack()
{
    if (stackSize != 0)
    {
        for (int i = 0; i < stackSize; i++)
        {
            cout << " " << stack[i];
        }
    }
}



#endif /* PA3_H_ */
